## libfixmath 0~20220222

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(libfixmath LANGUAGES CXX C)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_FLAGS "-Wall -pedantic -Wextra -Werror=return-type")

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_FLAGS "-Wall -pedantic -Wextra -Werror=return-type")

include(libfixmath/libfixmath.cmake)
include(tests/tests.cmake)

file(GLOB fixsingen-srcs fixsingen/*.c)
file(GLOB fixtest-srcs fixtest/*.c fixtest/*.h)

add_executable(fixtest ${fixtest-srcs})
target_link_libraries(fixtest PRIVATE libfixmath m)
target_include_directories(fixtest PRIVATE ${CMAKE_SOURCE_DIR})

add_executable(fixsingen ${fixsingen-srcs})
target_link_libraries(fixsingen PRIVATE libfixmath m)
target_include_directories(fixsingen PRIVATE ${CMAKE_SOURCE_DIR})

=== Makefile ===
# These are testcases & benchmarks for the library on the target processors
# (currently ARM Cortex M3 and AVR). They are a bit tricky to run, as they
# depend on specific simulator versions.

FILES = benchmark.c interface.c ../libfixmath/fix16.c ../libfixmath/fix16_sqrt.c ../libfixmath/fix16_exp.c

CFLAGS = -std=gnu11 -I../libfixmath

.PHONY clean:
	rm -f *.elf

testcases.c: generate_testcases.py
	python $<

benchmark-arm.elf: $(FILES) interface-arm.c testcases.c
	# Note: this needs hacked QEmu that "makes no sense":
	# https://bugs.launchpad.net/qemu/+bug/696094
	arm-none-eabi-gcc -mcpu=cortex-m3 -mthumb -T generic-m-hosted.ld \
		-Wall -O2 $(CFLAGS) \
		-o $@ -I .. $(FILES) interface-arm.c -lm

run-benchmark-arm: benchmark-arm.elf
	qemu-system-arm -cpu cortex-m3 -icount 0 -device armv7m_nvic \
		-nographic -monitor null -serial null \
		-semihosting -kernel $<

benchmark-avr.elf: $(FILES) interface-avr.c testcases.c
	avr-gcc -Wall -mmcu=atmega128 $(CFLAGS) \
		-O2 -DFIXMATH_OPTIMIZE_8BIT \
		-o $@ -I .. $(FILES) interface-avr.c

run-benchmark-avr: benchmark-avr.elf
	# Note: this needs simulavrxx 1.0rc0 or newer
	simulavr -d atmega128 -f $< -W 0x20,- -T exit

=== debian/changelog ===
libfixmath (0~20220222-3) unstable; urgency=medium

  * add-Vcs-Browser:/Git:
  * upload to unstable

 -- Rene Engelhard <rene@debian.org>  Sun, 03 Apr 2022 14:54:37 +0000

libfixmath (0~20220222-2) experimental; urgency=medium

  * fix Upstream-Contact:
  * don't build the tests on architectures where we don't have -lubsan
  * don't install the test .as, only liblibfixmath.a itself
  * link the tests with -latomic 

 -- Rene Engelhard <rene@debian.org>  Wed, 23 Mar 2022 19:16:05 +0000

libfixmath (0~20220222-1) experimental; urgency=medium

  * Initial release

 -- Rene Engelhard <rene@debian.org>  Sun, 20 Mar 2022 10:33:18 +0000

=== debian/control ===
Source: libfixmath
Priority: optional
Maintainer: Rene Engelhard <rene@debian.org>
Build-Depends: debhelper-compat (= 13), cmake
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/PetteriAimonen/libfixmath
Vcs-Browser: https://salsa.debian.org/debian/libfixmath
Vcs-Git: https://salsa.debian.org/debian/libfixmath.git
Rules-Requires-Root: no

Package: libfixmath-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Description: Cross Platform Fixed Point Maths Library
 Libfixmath implements Q16.16 format fixed point operations in C

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

%:
	dh $@

# the tests want to link with -lubsan
UBSAN_ARCHS=amd64 arm64 armel armhf i386 ppc64el s390x
UBSAN_ARCHS += powerpc
ifeq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
ENABLE_TESTS=n
else
ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),$(UBSAN_ARCHS)))
ENABLE_TESTS=y
else
ENABLE_TESTS=n
endif
endif

ifeq ($(ENABLE_TESTS),y)
override_dh_auto_configure:
	dh_auto_configure
else
override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_TESTS=OFF

override_dh_auto_test:

endif
